---
title: product_selection
description: 
published: true
date: 2022-01-31T19:41:46.635Z
tags: 
editor: markdown
dateCreated: 2022-01-31T19:31:39.115Z
---

# 1. Product selection

Below are several tables filled with state of the art technologies in their respective product category. General requirements for all product categories are:

- Costs associated with acquiring, operating and maintaining the product. An open source solution or one with a generous free tier would be suitable here.
- Complexity should be at a minimum with ease of use
- Extendibility by means of a plugin system of sorts
- The mangement, operation and maintenance burden should be at a minimum.
- Its reliability, errors and known issue's.
- The traction it has among the users community within the same space, such as Kubernetes, OpenStack and general Cloud-Native and containerized environments.
  - Its CNCF (Cloud-Native Computing Foundation) status, such as Sanbox, Incubation and Graduated. Or the results of CNCF End-user radars.
  - The amount of official documentation and guides provided by the community play a big role.
- Option for commercial support.

## 1.1. Kubernetes distributions for local development

A local Kubernetes distribution is an essential part of the development setup when working with applications running in Kubernetes. Its possible to develop with Docker or Docker-compose, however we want to simulate a production environment. This means we want to develop in a Kubernetes environment and eliminate as many differences as possible between production and development.

- **Kubernetes** - An open-source container-orchestration system for automating computer application deployment, scaling, and management.[5] It was originally designed by Google and is now maintained by the Cloud Native Computing Foundation. It aims to provide a "platform for automating deployment, scaling, and operations of Container workloads". It works with a range of container tools and runs containers in a cluster, often with images built using Docker. Kubernetes originally interfaced with the Docker runtime through a "Dockershim"; however, the shim has since been deprecated in favor of directly interfacing with the container through containerd, or replacing Docker with a runtime that is compliant with the Container Runtime Interface (CRI) introduced by Kubernetes in 2016. [Wikipedia](https://en.wikipedia.org/wiki/Kubernetes)
- **Deployment environment** - In software deployment, an environment, or tier is a computer system or set of systems in which a computer program or software component is deployed and executed. In simple cases, such as developing and immediately executing a program on the same machine, there may be a single environment, but in industrial use, the development environment (where changes are originally made) and production environment (what end users use) are separated, often with several stages in between. This structured release management process allows phased deployment (rollout), testing, and rollback in case of problems. [Wikipedia](https://en.wikipedia.org/wiki/Deployment_environment)

Environments may vary significantly in size: the development environment is typically an individual developer's workstation, while the production environment may be a network of many geographically distributed machines in data centers, or virtual machines in cloud computing. Code, data, and configuration may be deployed in parallel, and need not connect to the corresponding tier—for example, pre-production code might connect to a production database.

Many cloud services offer a Kubernetes-based platform or infrastructure as a service (PaaS or IaaS) on which Kubernetes can be deployed as a platform-providing service. Many vendors also provide their own branded Kubernetes distributions.


| Properties / features<br /> | Description                                     | Weight | MicroK8s                                                | Score | Calc | MiniKube                                                                                        | Score | Calc | Docker desktop                                                                                                    | Score | Calc | K3d                                                    | Score | Calc | Kind                                                                                                      | Score | Calc | Rancher desktop                                                            | Score | Calc |
| ----------------------------- | ------------------------------------------------- | -------- | --------------------------------------------------------- | ------- | ------ | ------------------------------------------------------------------------------------------------- | ------- | ------ | ------------------------------------------------------------------------------------------------------------------- | ------- | ------ | -------------------------------------------------------- | ------- | ------ | ----------------------------------------------------------------------------------------------------------- | ------- | ------ | ---------------------------------------------------------------------------- | ------- | ------ |
| Entry level                 | How complicated the project is                  | 10     | Medium                                                  | 1     | 10   | High                                                                                            | 0     | 0    | Low                                                                                                               | 2     | 20   | Medium                                                 | 1     | 10   | Medium                                                                                                    | 1     | 10   | Low                                                                        | 2     | 20   |
| OS                          | Supported operating systems                     | 10     | Windows, MacOS & Linux\*prefers Ubuntu                  | 1     | 10   | Windows, MacOS & Linux                                                                          | 3     | 30   | Windows & MacOS                                                                                                   | 2     | 20   | Windows, MacOS & Linux                                 | 3     | 30   | Windows, MacOS & Linux                                                                                    | 3     | 30   | Windows & MacOS                                                            | 2     | 20   |
| Lightweight                 | Resource consumption                            | 10     | Yes                                                     | 1     | 10   | No                                                                                              | 0     | 0    | No                                                                                                                | 0     | 0    | Yes                                                    | 1     | 10   | Yes                                                                                                       | 1     | 10   | Yes                                                                        | 1     | 10   |
| Interface                   | GUI or CLI                                      | 10     | CLI                                                     | 0     | 0    | CLI                                                                                             | 0     | 0    | GUI                                                                                                               | 1     | 10   | CLI                                                    | 0     | 0    | CLI                                                                                                       | 0     | 0    | GUI                                                                        | 1     | 10   |
| Multi-node                  | Abillity for multi-node clusters                | 5      | Yes                                                     | 1     | 5    | No                                                                                              | 0     | 0    | No                                                                                                                | 0     | 0    | Yes                                                    | 1     | 5    | Yes                                                                                                       | 1     | 5    | No                                                                         | 0     | 0    |
| Configurable K8s version    | Setting Kubernetes version to mirror production | 5      | No                                                      | 0     | 0    | No                                                                                              | 0     | 0    | No                                                                                                                | 0     | 0    | Yes                                                    | 1     | 5    | Yes                                                                                                       | 1     | 5    | Yes                                                                        | 1     | 5    |
| Reproducible                | Shareable configuration among developers        | 5      | No                                                      | 0     | 0    | No                                                                                              | 0     | 0    | No                                                                                                                | 0     | 0    | Yes                                                    | 1     | 5    | Yes                                                                                                       | 1     | 5    | No                                                                         | 0     | 0    |
| Image management            | Abillity to manage container images             | 5      | No                                                      | 0     | 0    | No                                                                                              | 0     | 0    | Yes                                                                                                               | 1     | 5    | No                                                     | 0     | 0    | No                                                                                                        | 0     | 0    | Yes                                                                        | 1     | 5    |
| Container runtime           | Available container runtime                     | 5      | Containerd                                              | 2     | 10   | Configurable                                                                                    | 3     | 15   | Docker                                                                                                            | 1     | 5    | Docker                                                 | 1     | 5    | Configurable                                                                                              | 3     | 15   | Containerd                                                                 | 2     | 10   |
| Virtualization              | Virtualisation technique                        | 5      | None/Multipass                                          | 1     | 5    | Configurable\*Default Docker                                                                    | 2     | 10   | WSL2/HyperKit                                                                                                     | 2     | 10   | Docker                                                 | 1     | 5    | Docker                                                                                                    | 1     | 5    | WSL2/Lima\*No access to priveledged ports                                  | 2     | 10   |
| Docs                        | Documentation site of the project               |        | [MicroK8s](https://microk8s.io/ "https://microk8s.io/") |       |      | [MiniKube](https://minikube.sigs.k8s.io/docs/start/ "https://minikube.sigs.k8s.io/docs/start/") |       |      | [Docker Desktop](https://www.docker.com/products/docker-desktop "https://www.docker.com/products/docker-desktop") |       |      | [K3D](https://k3d.io/v5.0.0/ "https://k3d.io/v5.0.0/") |       |      | [Kind](https://kind.sigs.k8s.io/docs/user/quick-start/ "https://kind.sigs.k8s.io/docs/user/quick-start/") |       |      | [Rancher Desktop](https://rancherdesktop.io/ "https://rancherdesktop.io/") |       |      |
|                             |                                                 |        | Total                                                   | 7     | 50   | Total                                                                                           | 8     | 55   | Total                                                                                                             | 9     | 70   | Total                                                  | 10    | 75   | Total                                                                                                     | 12    | 85   | Total                                                                      | 12    | 90   |

### 1.1.1. Selection and use cases

The choice for one solution is hard, because there're various use cases with different requirements.

#### 1.1.1.1. Ease of use

Docker desktop is the most popular and easy to use solution. It can however be ressource heavy, doesn't offer much flexibility and recently made big and impacting changes for many organizations. Large organizations (more than 250 employees or more than $10 million in revenue) requires users to have a paid Docker subscription. Personal use, non-commercial open source projects and education and learning use cases don't require a paid subscription.

Rancher Desktop aims to replace Docker desktop and eliminates the dependency on Docker, since it uses the ContainerD runtime. You're able to select a specific Kubernetes version, so you can eliminate differences from your production setup. It also provides a GUI, as Docker desktop does. Rancher desktop is a fairly young project and under active development. A downside is that no privileged ports (below 1028) can be accessed without manual intervention, however this features is in the works.

#### 1.1.1.2. Lightweight & Multi-node

Kind and K3D are in my opinion similar and score the same. They both focus on providing a lightweight and fast local Kubernetes setup, with the ability to run a multi-node setup within Docker. On Windows and MacOS this means you  need Docker Desktop as additional software.
They're both suitable for testing purposes involving multi-node use cases and are often deployed within CI/CD environments.

#### 1.1.1.3. Flexibility

MiniKube is the official and most feature-rich distribution for a local Kubernetes setup. However it can be slow and difficult to work with as everyday development environment. When in need for a feature-rich and flexible solution, this is your choiche.

## 1.2. Kubernetes live code updates

The developer's workflow should be as efficient as possible. Tooling facilitating live code updates will watch the project folder a developer is working in and automatically apply changes in the code's execution environment. Since we're using Kubernetes pods for our execution environment, the tooling facilitating live code updates must support deploying to Kubernetes.


| Properties / features | Description                                                        | Weight | Draft                                   | Score | Calc | Garden                            | Score | Calc | Skaffold                               | Score | Calc | DevSpace                                              | Score | Calc | Tilt                           | Score | Calc |
| ----------------------- | -------------------------------------------------------------------- | -------- | ----------------------------------------- | ------- | ------ | ----------------------------------- | ------- | ------ | ---------------------------------------- | ------- | ------ | ------------------------------------------------------- | ------- | ------ | -------------------------------- | ------- | ------ |
| Entry level           | How complicated the project is                                     | 10     | Low                                     | 2     | 20   | High                              | 0     | 0    | Medium                                 | 1     | 10   | Medium                                                | 1     | 10   | Medium                         | 1     | 10   |
| GUI                   | Interface that visualizes components                               | 10     | No                                      | 0     | 0    | Yes                               | 1     | 10   | No                                     | 0     | 0    | Yes                                                   | 1     | 10   | Yes                            | 1     | 10   |
| Focus                 | Local vs central development cluster                               | 10     | Local development                       | 2     | 20   | Central development               | 1     | 10   | Local development                      | 2     | 20   | Central development                                   | 1     | 10   | Local development              | 2     | 20   |
| Kustomize             | Support for Kustomize, Kubernetes configuration management project | 5      | No                                      | 0     | 0    | No                                | 0     | 0    | Yes                                    | 1     | 5    | Yes                                                   | 1     | 5    | Yes                            | 1     | 5    |
| Custom scripts        | Customisable / adding own functionallity                           | 5      | No                                      | 0     | 0    | Paid                              | 1     | 5    | Yes                                    | 1     | 5    | Yes                                                   | 1     | 5    | Yes                            | 1     | 5    |
| Docs                  | Documentation site of the project                                  |        | [Draft](https://github.com/Azure/draft) |       |      | [Garden](https://docs.garden.io/) |       |      | [Skaffold](https://skaffold.dev/docs/) |       |      | [DevSpace](https://devspace.sh/cli/docs/introduction) |       |      | [Tilt](https://docs.tilt.dev/) |       |      |
|                       |                                                                    |        | Total                                   | 4     | 20   | Total                             | 3     | 25   | Total                                  | 5     | 30   | Total                                                 | 5     | 30   | Total                          | 6     | 40   |

## 1.3. Kubernetes installers / distributions

Kubernetes installers are a way to install a Kubernetes cluster to a supported environment. A Kuberentes distribution is an opinionated way of installing a cluster and often includes a set of pre-defined cluster components / addons.
Kubernetes could be installed manually or partially manually, this however is complex, error prone, hard to manage and maintain. An installer will help the operator with the installation process of the cluster and sometimes even its lifecycle. A distribution often differentiates itself with the included addons and reduces the workload on the operator installing fresh clusters.

- **Software distribution** - Software distribution is the process of delivering software to the end user. A distro is a collection of software components built, assembled and configured so that it can essentially be used "as is". It is often the closest thing to turnkey form of free software. A distro may take the form of a binary distribution, with an executable installer which can be downloaded from the Internet. Examples range from whole operating system distributions to server and interpreter distributions (for example WAMP installers). Software distribution can also refer to careware and donateware. In recent years, the term has come to refer to nearly any "finished" software (i.e. something that is more or less ready for its intended use, whether as a complete system or a component of a larger system) that is assembled primarily from open source components. [Wikipedia](https://en.wikipedia.org/wiki/Software_distribution)


| Properties / features       | Description                                                          | Weight | Kubeadm                                                                                  | Score | Calc | Kops                                                                            | Score | Calc | RKE                                                                    | Score | Calc | Terraform                                                                                                              | Score | Calc | RKE2                                                                      | Score | Calc | K0s                                                                          | Score | Calc | KubeOne                                                                                  | Score | Calc | Cluster API                                                                                                    | Score | Calc  | Compliant Kubernetes                 | Score | Calc  | Crossplane                                                                                        | Score | Calc | Kubespray                                                                                                | Score | Calc |
| ----------------------------- | ---------------------------------------------------------------------- | -------- | ------------------------------------------------------------------------------------------ | ------- | ------ | --------------------------------------------------------------------------------- | ------- | ------ | ------------------------------------------------------------------------ | ------- | ------ | ------------------------------------------------------------------------------------------------------------------------ | ------- | ------ | --------------------------------------------------------------------------- | ------- | ------ | ------------------------------------------------------------------------------ | ------- | ------ | ------------------------------------------------------------------------------------------ | ------- | ------ | ---------------------------------------------------------------------------------------------------------------- | ------- | ------- | -------------------------------------- | ------- | ------- | --------------------------------------------------------------------------------------------------- | ------- | ------ | ---------------------------------------------------------------------------------------------------------- | ------- | ------ |
| OpenStack support           | Support for OpenStack cloud provider                                 | 15     | Ad-hoc                                                                                   | 2     | 30   | Yes\*Beta                                                                       | 1     | 15   | Yes                                                                    | 3     | 45   | Yes                                                                                                                    | 3     | 45   | Ad-hoc                                                                    | 2     | 30   | Ad-hoc                                                                       | 2     | 30   | Ad-hoc                                                                                   | 2     | 30   | Yes                                                                                                            | 3     | 45    | Yes                                  | 3     | 45    | Yes                                                                                               | 3     | 45   | Yes                                                                                                      | 3     | 45   |
| Entry level                 | How complicated the project is                                       | 10     | High                                                                                     | 0     | 0    | Low                                                                             | 2     | 20   | Low                                                                    | 2     | 20   | Medium                                                                                                                 | 1     | 10   | Low                                                                       | 2     | 20   | Low                                                                          | 2     | 20   | High                                                                                     | 0     | 0    | High                                                                                                           | 0     | 0     | Medium                               | 1     | 10    | Medium                                                                                            | 1     | 10   | Low                                                                                                      | 2     | 20   |
| Automated Installation      | Minimal manual labor, instead automated deployment                   | 10     | No                                                                                       | 0     | 0    | Yes                                                                             | 1     | 10   | Yes                                                                    | 1     | 10   | Yes                                                                                                                    | 1     | 10   | Yes                                                                       | 1     | 10   | Yes                                                                          | 1     | 10   | Yes                                                                                      | 1     | 10   | Yes                                                                                                            | 1     | 10    | Yes                                  | 1     | 10    | Yes                                                                                               | 1     | 10   | Yes                                                                                                      | 1     | 10   |
| Container runtime           | Available container runtime                                          | 10     | configurable                                                                             | 2     | 20   | configurable                                                                    | 2     | 20   | Docker                                                                 | 0     | 0    | Ad-hoc                                                                                                                 | 1     | 10   | containerd                                                                | 1     | 10   | configurable                                                                 | 2     | 20   | configurable                                                                             | 2     | 20   | Ad-hoc                                                                                                         | 1     | 10    | containerd                           | 1     | 10    | Ad-hoc                                                                                            | 1     | 10   | configurable                                                                                             | 2     | 20   |
| Lifecycle Management        | Managing the lifecycle of deployed clusters, e.g. updating, deletion | 5      | Yes                                                                                      | 1     | 5    | No                                                                              | 0     | 0    | No                                                                     | 0     | 0    | Ad-hoc                                                                                                                 | 1     | 5    | No                                                                        | 0     | 0    | Yes                                                                          | 1     | 5    | Yes                                                                                      | 1     | 5    | Yes                                                                                                            | 1     | 5     | Yes                                  | 1     | 5     | Ad-hoc                                                                                            | 1     | 5    | Yes                                                                                                      | 1     | 5    |
| Infrastructure Provisioning | Provisioning infrastructure in the same project                      | 5      | No                                                                                       | 0     | 0    | Yes                                                                             | 1     | 5    | No                                                                     | 0     | 0    | Yes                                                                                                                    | 1     | 5    | No                                                                        | 0     | 0    | No                                                                           | 0     | 0    | Yes                                                                                      | 1     | 5    | Yes                                                                                                            | 1     | 5     | Yes                                  | 1     | 5     | Yes                                                                                               | 1     | 5    | No                                                                                                       | 0     | 0    |
| Technologies                | Used technologies within the project                                 | 5      | N/A                                                                                      | 0     | 0    | N/A                                                                             | 0     | 0    | N/A                                                                    | 0     | 0    | N/A                                                                                                                    | 0     | 0    | Best from RKE, K3s                                                        | 2     | 10   | N/A                                                                          | 0     | 0    | Kubeadm, Ansible, Terraform, Cluster API                                                 | 3     | 15   | Kuberentes, kubeadm                                                                                            | 2     | 10    | Terraform, Kubespray                 | 2     | 10    | Kubernetes,\*Cluster API                                                                          | 2     | 10   | kubeadm, SSH, Ansible                                                                                    | 2     | 10   |
| CNCF                        | Cloud-Native Computing Foundation stage                              | 5      | Sandbox                                                                                  | 1     | 5    | Sandbox                                                                         | 1     | 5    | Sandbox                                                                | 1     | 5    | Member                                                                                                                 | 1     | 5    | Sandbox                                                                   | 1     | 5    | Sandbox                                                                      | 1     | 5    | Sandbox                                                                                  | 1     | 5    | Kubernetes child                                                                                               | 2     | 10    | Sandbox                              | 1     | 5     | Incubating                                                                                        | 2     | 10   | Sandbox                                                                                                  | 1     | 5    |
| Home                        | Company / project behind the initiative                              | 2,5    | Kubernetes                                                                               | 2     | 5    | Kubernetes                                                                      | 2     | 5    | Rancher                                                                | 1     | 2,5  | Hashicorp                                                                                                              | 1     | 2,5  | Rancher                                                                   | 1     | 2,5  | Mirantis                                                                     | 1     | 2,5  | Kubermatic                                                                               | 1     | 2,5  | Kubernetes SIGs                                                                                                | 2     | 5     | Elastisys                            | 1     | 2,5   | Upbound                                                                                           | 1     | 2,5  | Kubernetes SIGs                                                                                          | 2     | 5    |
| Miscellaneous               | Miscellaneous notes, for every project different                     | 2,5    | Standard ad-hoc method to deploy clusters                                                | 1     | 2,5  | Not flexible                                                                    | 0     | 0    | Easiest managed-like experience                                        | 2     | 5    | Infrastructure provisioning                                                                                            | 0     | 0    | Adds simplicity, installation methods and compliance                      | 2     | 5    | Various installation methods, including Docker                               | 2     | 5    | Utilizes and combines best-of breed technologies                                         | 2     | 5    | Official method to deploy clusters using a cluster                                                             | 1     | 2,5   | Additional components for Compliance | 2     | 5     | Cloud services provisioning on a cluster                                                          | 1     | 2,5  | Standard remote method to deploy clusters                                                                | 2     | 5    |
| Docs                        | Documentation site of the project                                    |        | [kubeadm](https://github.com/kubernetes/kubeadm "https://github.com/kubernetes/kubeadm") |       |      | [kops](https://github.com/kubernetes/kops "https://github.com/kubernetes/kops") |       |      | [RKE](https://github.com/rancher/rke "https://github.com/rancher/rke") |       |      | [Terraform providers](https://registry.terraform.io/browse/providers "https://registry.terraform.io/browse/providers") |       |      | [RKE2](https://github.com/rancher/rke2 "https://github.com/rancher/rke2") |       |      | [k0s](https://github.com/k0sproject/k0s "https://github.com/k0sproject/k0s") |       |      | [KubeOne](https://github.com/kubermatic/kubeone "https://github.com/kubermatic/kubeone") |       |      | [Cluster-API](https://github.com/kubernetes-sigs/cluster-api "https://github.com/kubernetes-sigs/cluster-api") |       |       | Compliant Kubernetes                 |       |       | [crossplane](https://github.com/crossplane/crossplane "https://github.com/crossplane/crossplane") |       |      | [kubespray](https://github.com/kubernetes-sigs/kubespray "https://github.com/kubernetes-sigs/kubespray") |       |      |
|                             |                                                                      |        | Total                                                                                    | 9     | 67,5 | Total                                                                           | 10    | 80   | Total                                                                  | 10    | 87,5 | Total                                                                                                                  | 10    | 92,5 | Total                                                                     | 12    | 92,5 | Total                                                                        | 12    | 97,5 | Total                                                                                    | 14    | 97,5 | Total                                                                                                          | 14    | 102,5 | Total                                | 14    | 107,5 | Total                                                                                             | 14    | 110  | Total                                                                                                    | 16    | 125  |

## 1.4. Kubernetes declarative & DRY (Don't Repeat Yourself) configuration

Kubernetes manifest are the standard method of declaring application for Kubernetes. However, this can be hard to manage and even more so when the application grows in terms of added components and complexity. Helm helps with this and is often described as the package manager for Kubernetes. Therfore it's moslty used for third-party applications and not so for internally developed applications. The Joint Cyber Range aims for a GitOps way of managing software configuration and infrastructure, essential for this is a declarative way of describing components. Managing the values with which a Helm chart is configured contradicts the declarative approach. Templating is an essential part for a DRY (Don't Repeat Yourself) configuration. Templating is indispensable when you want to offer something as a service for various tenants or in different environments, such as development, testing and production.

* Declarative - In computer science, declarative programming is a programming paradigm—a style of building the structure and elements of computer programs—that expresses the logic of a computation without describing its control flow. [Wikipedia](https://en.wikipedia.org/wiki/Declarative_programming)
* DRY - "Don't repeat yourself" (DRY, or sometimes "do not repeat yourself") is a principle of software development aimed at reducing repetition of software patterns, replacing it with abstractions or using data normalization to avoid redundancy. [Wikipedia](https://en.wikipedia.org/wiki/Don%27t_repeat_yourself)


| Properties / features  | Description                                                            | Weight | Kubecfg                                       | Score | Calc | Kapitan                         | Score | Calc | Tanka                       | Score | Calc | Helm                          | Score | Calc | Kustomize                                                 | Score | Calc |
| ------------------------ | ------------------------------------------------------------------------ | -------- | ----------------------------------------------- | ------- | ------ | --------------------------------- | ------- | ------ | ----------------------------- | ------- | ------ | ------------------------------- | ------- | ------ | ----------------------------------------------------------- | ------- | ------ |
| Entry level            | How complicated the project is                                         | 10     | High                                          | 0     | 0    | High                            | 0     | 0    | High                        | 0     | 0    | Low                           | 2     | 20   | Medium                                                    | 1     | 10   |
| Integrated in projects | If the technology is supported by projects in the k8s ecosystem        | 10     | No                                            | 0     | 0    | No                              | 0     | 0    | No                          | 0     | 0    | Yes                           | 1     | 10   | Yes                                                       | 1     | 10   |
| Templating             | Technique utilized for templating                                      | 10     | Jsonnet                                       | 1     | 10   | Various choices                 | 2     | 20   | Jsonnet                     | 1     | 10   | Requires extending Helm       | 0     | 0    | Overlays                                                  | 2     | 20   |
| Open support resources | Freely available support resources on the internet, e.g. blogs, videos | 10     | Low                                           | 1     | 10   | Low                             | 1     | 10   | Medium                      | 2     | 20   | High                          | 3     | 30   | High                                                      | 3     | 30   |
| Docs                   | Documentation site of the project                                      |        | [Kubecfg](https://github.com/bitnami/kubecfg) |       |      | [Kapitan](https://kapitan.dev/) |       |      | [Tanka](https://tanka.dev/) |       |      | [Helm](https://helm.sh/docs/) |       |      | [Kustomize](https://kubernetes-sigs.github.io/kustomize/) |       |      |
|                        |                                                                        |        | Total                                         | 2     | 20   | Total                           | 3     | 30   | Total                       | 3     | 30   | Total                         | 6     | 60   | Total                                                     | 7     | 70   |

## 1.5. Git code repositories

Before we had code repositories, code was stored de-centralized or on some kind of central file server. This makes sharing code and collaborating on it somwewhat difficult. Another problem is the keeping a history of changes and having all team members working on the most recent version. Nowadays code is stored centrally on a code repository and within a version control system, where the most common one is Git. Wikipedia

- **Git** - Git is software for tracking changes in any set of files, usually used for coordinating work among programmers collaboratively developing source code during software development. Its goals include speed, data integrity, and support for distributed, non-linear workflows (thousands of parallel branches running on different systems). [Wikipedia](https://en.wikipedia.org/wiki/Git)
- **Code repository** - In revision control systems, a repository is a data structure that stores metadata for a set of files or directory structure. Depending on whether the version control system in use is distributed like (Git or Mercurial) or centralized like (Subversion, CVS, or Perforce), the whole set of information in the repository may be duplicated on every user's system or may be maintained on a single server.[2] Some of the metadata that a repository contains includes, among other things: A historical record of changes in the repository, a set of commit objects and a set of references to commit objects, called heads. [Wikipedia](https://en.wikipedia.org/wiki/Repository_(version_control))


| Properties / features | Description                          | Weight | GitHub                               | Score | Calc | Azure Repo                                                                           | Score | Calc | GitLab                             | Score | Calc |
| ----------------------- | -------------------------------------- | -------- | -------------------------------------- | ------- | ------ | -------------------------------------------------------------------------------------- | ------- | ------ | ------------------------------------ | ------- | ------ |
| Free tier             | Free option to use the project       | 10     | Yes                                  | 1     | 10   | Yes                                                                                  | 1     | 10   | Yes / self-hosted                  | 3     | 30   |
| Best for              | The target group / category of users | 2,5    | Open-source projects/entry level     | 1     | 2,5  | Microsoft/Azure tech-stack                                                           | 2     | 5    | Enterprise                         | 1     | 2,5  |
| Docs                  | Documentation site of the project    |        | [GitHub](https://docs.github.com/en) |       |      | [Azure Repo](https://docs.microsoft.com/en-us/azure/devops/repos/?view=azure-devops) |       |      | [GitLab](https://docs.gitlab.com/) |       |      |
|                       |                                      |        | Total                                | 2     | 12,5 | Total                                                                                | 3     | 15   | Total                              | 4     | 32,5 |

## 1.6. CI/CD pipelines

**CI/CD** - In software engineering, CI/CD or CICD is the combined practices of continuous integration (CI) and either continuous delivery or continuous deployment (CD). CI/CD bridges the gaps between development and operation activities and teams by enforcing automation in building, testing and deployment of applications. The process contrasts with traditional methods where all updates were integrated into one large batch before rolling out the newer version. Modern day DevOps practices involve continuous development, continuous testing, continuous integration, continuous deployment and continuous monitoring of software applications throughout its development life cycle. The CI/CD practice, or CI/CD pipeline, forms the backbone of modern day DevOps operations. [Wikipedia](https://en.wikipedia.org/wiki/CI/CD)

**CI** - In software engineering, continuous integration (CI) is the practice of merging all developers' working copies to a shared mainline several times a day. [Wikipedia](https://en.wikipedia.org/wiki/Continuous_integration)

**CD** - Continuous delivery (CD) is a software engineering approach in which teams produce software in short cycles, ensuring that the software can be reliably released at any time and, when releasing the software, without doing so manually. Continuous delivery aims at building, testing, and releasing software with greater speed and frequency. The approach helps reduce the cost, time, and risk of delivering changes by allowing for more incremental updates to applications in production. A straightforward and repeatable deployment process is important for continuous delivery. [Wikipedia](https://en.wikipedia.org/wiki/Continuous_delivery)
Continous Deployment expands Continous Delivery from manual deployment to automated.

![https://s7280.pcdn.co/wp-content/uploads/2017/06/ci-vs-cd-devops-difference.jpg](https://s7280.pcdn.co/wp-content/uploads/2017/06/ci-vs-cd-devops-difference.jpg)

| Properties / features | Description                          | Weight | Azure DevOps                                                                     | Score | Calc | GitHub                                       | Score | Calc | Tekton                             | Score | Calc | Argo Workflow                                               | Score | Calc | GitLab                                   | Score | Calc |
| ----------------------- | -------------------------------------- | -------- | ---------------------------------------------------------------------------------- | ------- | ------ | ---------------------------------------------- | ------- | ------ | ------------------------------------ | ------- | ------ | ------------------------------------------------------------- | ------- | ------ | ------------------------------------------ | ------- | ------ |
| Free tier             | Free option to use the project       | 10     | Yes                                                                              | 1     | 10   | Yes                                          | 1     | 10   | Open-source                        | 2     | 20   | Open-source                                                 | 2     | 20   | Yes / self-hosted                        | 3     | 30   |
| Best for              | The target group / category of users | 2,5    | Microsoft/Azure tech-stack                                                       | 2     | 5    | Open-source projects/entry level             | 1     | 2,5  | Kubernetes native environments     | 1     | 2,5  | Argo ecosystem                                              | 1     | 2,5  | Enterprise                               | 1     | 2,5  |
| Marketplace           | Community catalogue of artifacts     | 5      | No                                                                               | 0     | 0    | Yes                                          | 1     | 5    | Yes                                | 1     | 5    | No                                                          | 1     | 5    | No                                       | 0     | 0    |
| Docs                  | Documentation site of the project    |        | [Azure DevOps](https://docs.microsoft.com/en-us/azure/devops/?view=azure-devops) |       |      | [GitHub](https://docs.github.com/en/actions) |       |      | [Tekton](https://tekton.dev/docs/) |       |      | [Argo Workflow](https://argoproj.github.io/argo-workflows/) |       |      | [GitLab](https://docs.gitlab.com/ee/ci/) |       |      |
|                       |                                      |        | Total                                                                            | 3     | 15   | Total                                        | 3     | 17,5 | Total                              | 4     | 27,5 | Total                                                       | 4     | 27,5 | Total                                    | 4     | 32,5 |

## 1.7. GitOps Operators

GitOps is an extension of already well-established DevOps best-practices, such as CI/CD, secrets management and Infrastructure as Code.

**GitOps** - A way of implementing Continuous Deployment for cloud native applications. It focuses on a developer-centric experience when operating infrastructure, by using tools developers are already familiar with, including Git and Continuous Deployment tools. The core idea of GitOps is having a Git repository that always contains declarative descriptions of the infrastructure currently desired in the production environment and an automated process to make the production environment match the described state in the repository. If you want to deploy a new application or update an existing one, you only need to update the repository - the automated process handles everything else. It’s like having cruise control for managing your applications in production. [GitOps.tech](https://www.gitops.tech/)


| Properties / features     | Description                                                            | Weight | Project: Syn                                             | Score | Calc | Spinnaker                                      | Score | Calc | Jenkins X                                   | Score | Calc | Weave GitOps Core                                               | Score | Calc | GimletD                       | Score | Calc | Flux v2                         | Score | Calc | Argo CD                                             | Score | Calc |
| --------------------------- | ------------------------------------------------------------------------ | -------- | ---------------------------------------------------------- | ------- | ------ | ------------------------------------------------ | ------- | ------ | --------------------------------------------- | ------- | ------ | ----------------------------------------------------------------- | ------- | ------ | ------------------------------- | ------- | ------ | --------------------------------- | ------- | ------ | ----------------------------------------------------- | ------- | ------ |
| Entry level               | How complicated the project is                                         | 10     | Medium                                                   | 1     | 10   | High                                           | 0     | 0    | High                                        | 0     | 0    | Low                                                             | 2     | 20   | Low                           | 2     | 20   | Medium                          | 1     | 10   | Medium                                              | 1     | 10   |
| Kustomize                 | Support for Kustomize, Kubernetes configuration management project     | 10     | No                                                       | 0     | 0    | Yes                                            | 1     | 10   | Yes                                         | 1     | 10   | Yes                                                             | 1     | 10   | Yes                           | 1     | 10   | Yes                             | 1     | 10   | Yes                                                 | 1     | 10   |
| Open support resources    | Freely available support resources on the internet, e.g. blogs, videos | 10     | Low                                                      | 1     | 10   | Medium                                         | 2     | 20   | Medium/High                                 | 2,5   | 25   | Low                                                             | 1     | 10   | Low                           | 1     | 10   | High                            | 3     | 30   | High                                                | 3     | 30   |
| CNCF                      | Cloud-Native Computing Foundation stage                                | 5      | No                                                       | 0     | 0    | Sandbox                                        | 1     | 5    | Sandbox                                     | 1     | 5    | No                                                              | 0     | 0    | No                            | 0     | 0    | Incubating                      | 2     | 10   | Incubating                                          | 2     | 10   |
| GUI                       | Interface that visualizes components                                   | 5      | Yes\*No screenshots                                      | 0,5   | 2,5  | Yes                                            | 1     | 5    | Yes                                         | 1     | 5    | Yes                                                             | 1     | 5    | Yes                           | 1     | 5    | No                              | 0     | 0    | Yes                                                 | 1     | 5    |
| Bare-bone or feature rich | How much features / functionallity is in one tool                      | 2,5    | Based on Argo CD                                         | 3     | 7,5  | Feature rich                                   | 1     | 2,5  | Feature rich                                | 2     | 5    | Based on Flux                                                   | 3     | 7,5  | Based on Flux                 | 3     | 7,5  | Bare-bone                       | 2     | 5    | Bare-bone                                           | 2     | 5    |
| Multiple platforms        | Deployement capabilitues outside of Kubernetes                         | 2,5    | No                                                       | 0     | 0    | Yes                                            | 1     | 2,5  | No                                          | 0     | 0    | No                                                              | 0     | 0    | No                            | 0     | 0    | No                              | 0     | 0    | No                                                  | 0     | 0    |
| Docs                      | Documentation site of the project                                      |        | [Project Syn](https://syn.tools/syn/about/features.html) |       |      | [Spinnaker](https://spinnaker.io/docs/guides/) |       |      | [Jenkins X](https://jenkins-x.io/v3/about/) |       |      | [Weave GitOps Core](https://github.com/weaveworks/weave-gitops) |       |      | [GimletD](https://gimlet.io/) |       |      | [Flux](https://fluxcd.io/docs/) |       |      | [ArgoCD](https://argo-cd.readthedocs.io/en/stable/) |       |      |
|                           |                                                                        |        | Total                                                    | 5,5   | 30   | Total                                          | 7     | 45   | Total                                       | 7,5   | 50   | Total                                                           | 8     | 52,5 | Total                         | 8     | 52,5 | Total                           | 9     | 65   | Total                                               | 10    | 70   |

Flux and ArgoCD are the main two GitOps operators. GitOps originated at Weaveworks, the company behind Flux, but nowadays the two projects are very similar in feature-sets. Whenever Flux or ArgoCD introduces a new feature, the other project quickly integrates the same functionally. Flux is more popular with big companies building a service on top of it. However ArgoCD has a more complete ecosystem of accompanying projects, both official (Argo Wokflow, events & rollouts) and by the community. Spinnaker differentiate itself from the rest being compatible with more platforms than only Kubernetes, however it's know to be complex and can be hard to setup, operate and maintain. Jenkins X is the most feature rich option, but often the complaint about that is it's trying to to too much at once. The other projects listed are fairly new, but have the approach of either using Flux or ArgoCD as its core GitOps operator.

## 1.8. Centralized secret management

Secrets should not be hard-coded in applications code, but also should not live inside separate environment files. Secrets should be centrally managed for security purposes and ease of operation. When secrets live in a centralized secret store, various controls can be enforced to keep the data confidential. Access control, encryption and rotation are possibilities in this product category. Note that the serets management solution must also be supported by the GitOps operator or in the configuration manifests (Kustomize). Note that you should mount secrets as close as possible to the target that needs them.

For Kubernetes this entails not storing them in etcd. You should mount them directly on the application level, either in the code using a SDK or adapting the sidecar pattern.

- **Secrets management** - A cybersecurity best practice for digital businesses, secrets management allows organizations to consistently enforce security policies for non-human identities. Secrets management provides assurance that resources across tool stacks, platforms and cloud environments can only be accessed by authenticated and authorized entities. Authenticate all access requests that use non-human credentials. The following steps are typically included in a secrets management initiative. Many of these approaches and techniques are also used to protect privileged access by human users:
  - Enforce the principle of least privilege.
  - Enforce role-based access control (RBAC) and regularly rotate secrets and credentials.
  - Automate management of secrets and apply consistent access policies.
  - Track all access and maintain a comprehensive audit.
  - Remove secrets from code, configuration files and other unprotected areas. [CyberArk](https://www.cyberark.com/what-is/secrets-management/)


| Properties / features  | Description                                                            | Weight | SecretHub                                                  | Score | Calc | GCP Secrets Manager                                                                                                | Score | Calc | AWS KMS                                                                                            | Score | Calc | AWS Secrets Manager                                                                                              | Score | Calc | Hashiocorp Vault                                                                       | Score | Calc | CyberArk Conjur                                                                                                                                                                                                                        | Score | Calc | Azure Key Vault                                                                                                          | Score | Calc | Doppler                                                                  | Score | Calc |
| ------------------------ | ------------------------------------------------------------------------ | -------- | ------------------------------------------------------------ | ------- | ------ | -------------------------------------------------------------------------------------------------------------------- | ------- | ------ | ---------------------------------------------------------------------------------------------------- | ------- | ------ | ------------------------------------------------------------------------------------------------------------------ | ------- | ------ | ---------------------------------------------------------------------------------------- | ------- | ------ | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ------- | ------ | -------------------------------------------------------------------------------------------------------------------------- | ------- | ------ | -------------------------------------------------------------------------- | ------- | ------ |
| Available licences     | Already available commercial licenses                                  | 15     | No                                                         | 0     | 0    | No                                                                                                                 | 0     | 0    | No                                                                                                 | 0     | 0    | No                                                                                                               | 0     | 0    | No                                                                                     | 0     | 0    | No                                                                                                                                                                                                                                     | 0     | 0    | Yes                                                                                                                      | 1     | 15   | No                                                                       | 0     | 0    |
| Entry level            | How complicated the project is                                         | 10     | Low                                                        | 2     | 20   | Medium                                                                                                             | 1     | 10   | Medium                                                                                             | 1     | 10   | Medium                                                                                                           | 1     | 10   | High                                                                                   | 0     | 0    | Medium                                                                                                                                                                                                                                 | 1     | 0    | Medium                                                                                                                   | 1     | 10   | Low                                                                      | 2     | 20   |
| Open support resources | Freely available support resources on the internet, e.g. blogs, videos | 10     | Low                                                        | 1     | 10   | High                                                                                                               | 3     | 30   | High                                                                                               | 3     | 30   | High                                                                                                             | 3     | 30   | High                                                                                   | 3     | 30   | Low                                                                                                                                                                                                                                    | 1     | 30   | High                                                                                                                     | 3     | 30   | Medium/Low                                                               | 2,5   | 25   |
| Model                  | Bussiness model, open-source, commercial or both                       | 10     | Commercial                                                 | 0     | 0    | Commercial                                                                                                         | 0     | 0    | Commercial                                                                                         | 0     | 0    | Commercial                                                                                                       | 0     | 0    | open-source/commercial                                                                 | 1     | 10   | open-source/commercial                                                                                                                                                                                                                 | 1     | 10   | Commercial                                                                                                               | 0     | 0    | Commercial/Generous free-tier                                            | 2     | 20   |
| Hosting                | Available hosting methods, self-hosted, Cloud or SaaS                  | 10     | SaaS                                                       | 3     | 30   | Cloud                                                                                                              | 2     | 20   | Cloud                                                                                              | 2     | 20   | Cloud                                                                                                            | 2     | 20   | Self-hosted/Cloud                                                                      | 2     | 20   | Self-hosted/Cloud                                                                                                                                                                                                                      | 2     | 20   | Cloud                                                                                                                    | 2     | 20   | SaaS                                                                     | 3     | 30   |
| CNCF                   | Cloud-Native Computing Foundation stage                                | 5      | No                                                         | 0     | 0    | No                                                                                                                 | 0     | 0    | No                                                                                                 | 0     | 0    | No                                                                                                               | 0     | 0    | Silver member                                                                          | 1     | 5    | Sandbox                                                                                                                                                                                                                                | 1     | 5    | No                                                                                                                       | 0     | 0    | No                                                                       | 0     | 0    |
| CNCF End-user radar    | CNCF survey of users adopting projects                                 | 5      | N/A                                                        | 0     | 0    | Assess                                                                                                             | 1     | 5    | Adopt                                                                                              | 2     | 10   | Adopt                                                                                                            | 2     | 10   | Adopt                                                                                  | 2     | 10   | N/A                                                                                                                                                                                                                                    | 0     | 10   | N/A                                                                                                                      | 0     | 0    | N/A                                                                      | 0     | 0    |
| Docs                   | Documentation site of the project                                      |        | [SecretHub](https://secrethub.io/ "https://secrethub.io/") |       |      | [GCP Secrets Manager](https://cloud.google.com/secret-manager/docs "https://cloud.google.com/secret-manager/docs") |       |      | [AWS KMS](https://docs.aws.amazon.com/kms/index.html "https://docs.aws.amazon.com/kms/index.html") |       |      | [AWS Secrets Manager](https://docs.aws.amazon.com/secretsmanager/ "https://docs.aws.amazon.com/secretsmanager/") |       |      | [Hashicorp Vault](https://www.vaultproject.io/docs "https://www.vaultproject.io/docs") |       |      | [CyberArk Conjur](https://docs.cyberark.com/Product-Doc/OnlineHelp/AAM-DAP/Latest/en/Content/Resources/_TopNav/cc_Home.htm "https://docs.cyberark.com/Product-Doc/OnlineHelp/AAM-DAP/Latest/en/Content/Resources/_TopNav/cc_Home.htm") |       |      | [Azure Key Vault](https://docs.microsoft.com/en-us/azure/key-vault/ "https://docs.microsoft.com/en-us/azure/key-vault/") |       |      | [Doppler](https://docs.doppler.com/docs "https://docs.doppler.com/docs") |       |      |
|                        |                                                                        |        | Total                                                      | 6     | 60   | Total                                                                                                              | 7     | 65   | Total                                                                                              | 8     | 70   | Total                                                                                                            | 8     | 70   | Total                                                                                  | 9     | 75   | Total                                                                                                                                                                                                                                  | 6     | 75   | Total                                                                                                                    | 7     | 75   | Total                                                                    | 9,5   | 95   |

Hashicorp Vault has esteblished itself as industry standard for Kubernetes secrets management, but can be difficult to setup, operate and can result in a high maintenance burden. CyberArk is a prominent, or even the top vendor in the PAM (Privileged Access Management) market. Conjur offers an awesome technology, providing a secretless broker. This results in keeping secrets stored centralized, without sending the actual secret to the application. Technology aside, it hasn't gained much tracion in the community yet. Doppler offers a generous free tier, with unlimited users and secrets. It mostly focusses developers and therefore ease of use. It provides many integrations and even with third-party cloud-based secret management solutions from AWS, GCP and Azure. For solutions from cloud providers, AWS's Secret Manager and KMS are used a lot with the GCP Secret Manager trailing behind according to the [CNCF End-user raddar](https://radar.cncf.io/2021-02-secrets-management).

## 1.9. Static Site Generator

The Static Site Generator product category is filled with options. This list only includes the most common ones, that're easy to use. or focus on documentation. They mostly differentiate themselves with their complexity, scope, programming languages and templating technique.

- **Static web page** - A static web page (sometimes called a flat page or a stationary page) is a web page that is delivered to the user's web browser exactly as stored, in contrast to dynamic web pages which are generated by a web application. Consequently, a static web page displays the same information for all users, from all contexts, subject to modern capabilities of a web server to negotiate content-type or language of the document where such versions are available and the server is configured to do so. [Wikipedia](https://en.wikipedia.org/wiki/Static_web_page)
- **Static site generator** - A tool that generates a full static HTML website based on raw data and a set of templates. Essentially, a static site generator automates the task of coding individual HTML pages and gets those pages ready to serve to users ahead of time. Because these HTML pages are pre-built, they can load very quickly in users' browsers. Static site generators are an alternative to content management systems (CMS) — another type of tool for managing web content, generating webpages, and implementing templates. (A template is a reusable format for web content; developers use templates to avoid writing the same formatting over and over.) Static site generators are typically part of a JAMstack web development approach. [Cloudflare](https://www.cloudflare.com/nl-nl/learning/performance/static-site-generator/)
- **Jamstack** - Stands for Javascript, API and Markup (generated by a static site generator). In Jamstack websites, the application logic typically resides on the client side (for example embedded e-commerce checkout that interacts with pre-rendered static content), without being tightly coupled to the back end server. They are mostly served with git based CMS or headless CMS. The Jamstack is not a framework but is rather defined by [Jamstack.org](https://jamstack.org/) as an architecture pattern. [Wikipedia](https://en.wikipedia.org/wiki/Jamstack)


| Properties / features | Description                                    | Weight | Hugo                                     | Score | Calc | Gatsby                                   | Score | Calc | Jekyll                               | Score | Calc | Docsify                              | Score | Calc | Mkdocs                            | Score | Calc | GitBook                              | Score | Calc | Docusaurus                               | Score | Calc | Publii                                | Score | Calc |
| ----------------------- | ------------------------------------------------ | -------- | ------------------------------------------ | ------- | ------ | ------------------------------------------ | ------- | ------ | -------------------------------------- | ------- | ------ | -------------------------------------- | ------- | ------ | ----------------------------------- | ------- | ------ | -------------------------------------- | ------- | ------ | ------------------------------------------ | ------- | ------ | --------------------------------------- | ------- | ------ |
| Entry level           | How complicated the project is                 | 10     | Medium                                   | 1     | 10   | Medium                                   | 1     | 10   | Low                                  | 2     | 20   | Medium                               | 1     | 10   | Low                               | 1     | 10   | Low                                  | 1     | 10   | Medium                                   | 1     | 10   | Low                                   | 1     | 10   |
| Focus                 | The main focus and goal of the project         | 10     | Static site                              | 1     | 10   | Static site                              | 1     | 10   | Static site                          | 1     | 10   | Documentation                        | 2     | 20   | Documentation                     | 2     | 20   | Ease of use                          | 2     | 20   | Documentation                            | 2     | 20   | Ease of use                           | 2     | 20   |
| Language              | Programming language the project is built upon | 10     | Go                                       | 0     | 0    | JavaScript                               | 1     | 10   | Ruby                                 | 0     | 0    | JavaScript                           | 1     | 10   | Python                            | 1     | 10   | JavaScript                           | 1     | 10   | JavaScript                               | 1     | 10   | JavaScript                            | 1     | 10   |
| Templates             | Templating technology                          | 5      | Go                                       | 0     | 0    | React                                    | 0     | 0    | Liquid                               | 1     | 5    | Markdown, Vue                        | 1     | 5    | Jinja2                            | 1     | 5    | Jinja2                               | 1     | 5    | React, Markdown                          | 1     | 5    | Handlebars                            | 1     | 5    |
| Multi-language        | Site internationalization (i18n)               | 2,5    | Yes                                      | 1     | 2,5  | Plugin                                   | 1     | 2,5  | Plugin                               | 1     | 2,5  | Yes                                  | 1     | 2,5  | No                                | 0     | 0    | Yes                                  | 1     | 2,5  | Yes                                      | 1     | 2,5  | Yes                                   | 1     | 2,5  |
| CMS                   | Support for CMS (Content Management System)    | 2,5    | Addon                                    | 1     | 2,5  | Addon                                    | 1     | 2,5  | Addon                                | 1     | 2,5  | No                                   | 0     | 0    | Addon                             | 1     | 2,5  | Addon                                | 1     | 2,5  | Addon                                    | 1     | 2,5  | Yes                                   | 2     | 5    |
| Docs                  | Documentation site of the project              |        | [Hugo](https://gohugo.io/documentation/) |       |      | [Gatsby](https://www.gatsbyjs.com/docs/) |       |      | [Jekyll](https://jekyllrb.com/docs/) |       |      | [Docsify](https://docsify.js.org/#/) |       |      | [Mkdocs](https://www.mkdocs.org/) |       |      | [GitBook](https://docs.gitbook.com/) |       |      | [Docusaurus](https://docusaurus.io/docs) |       |      | [Publii](https://getpublii.com/docs/) |       |      |
|                       |                                                |        | Total                                    | 4     | 25   | Total                                    | 5     | 35   | Total                                | 6     | 40   | Total                                | 6     | 47,5 | Total                             | 6     | 47,5 | Total                                | 7     | 50   | Total                                    | 7     | 50   | Total                                 | 8     | 52,5 |

## 1.10. Static site hosting

Static Sites need a different way of hosting than more traditional sites, where the build process from source to site is an integral part of JAMstack applications. The amount of builds, total and individual build time plays a big role in this product selection. The total amount of storage and that of individual files is often limited, as is the bandwidth to and from your site. Important for the Joint Cyber Range is the amount of team members / collaborators that can work on a project and how access is controlled. Not all parts of the site should be publicly accessible, therefore some authentication method on the site itself is preferred.


| Properties / features | Description                                         | Weight | Render                            | Score | Calc | Vercel                                     | Score | Calc | Cloudflare Pages                                             | Score | Calc | Netlify        | Score | Calc | GitHub Pages                                     | Score | Calc | GitLab Pages                                                   | Score | Calc | Hostman                                       | Score | Calc | Azure Static Web Apps                                                            | Score | Calc |
| ----------------------- | ----------------------------------------------------- | -------- | ----------------------------------- | ------- | ------ | -------------------------------------------- | ------- | ------ | -------------------------------------------------------------- | ------- | ------ | ---------------- | ------- | ------ | -------------------------------------------------- | ------- | ------ | ---------------------------------------------------------------- | ------- | ------ | ----------------------------------------------- | ------- | ------ | ---------------------------------------------------------------------------------- | ------- | ------ |
| Available licences    | Already available commercial licenses               | 15     | No                                | 0     | 0    | No                                         | 0     | 0    | No                                                           | 0     | 0    | No             | 0     | 0    | No                                               | 0     | 0    | Limited                                                        | 2     | 30   | No                                            | 0     | 0    | Extensive                                                                        | 2     | 30   |
| Authentication        | Support for authentication on the site              | 10     | Unlisted                          | 0     | 0    | Unlisted                                   | 0     | 0    | Unlisted                                                     | 0     | 0    | Paid           | 0     | 0    | Paid                                             | 0     | 0    | Free tier                                                      | 1     | 10   | Yes                                           | 1     | 10   | Yes                                                                              | 1     | 10   |
| Git repository        | Private or only public Git repositories             | 10     | Private/Public                    | 1     | 10   | Private/Public                             | 1     | 10   | Private/Public                                               | 1     | 10   | Private/Public | 1     | 10   | Public                                           | 0     | 0    | Public                                                         | 0     | 0    | Private/Public                                | 1     | 10   | Private/Public                                                                   | 1     | 10   |
| Team members          | Number of team members / collaborators              | 10     | Unlimited                         | 1     | 10   | 1                                          | 0     | 0    | Unlimited                                                    | 1     | 10   | 1              | 0     | 0    | Unlimited                                        | 1     | 10   | Unlimited                                                      | 1     | 10   | Unlimited                                     | 1     | 10   | Unlimited                                                                        | 1     | 10   |
| Build limits          | Limit set on number of builds / build time          | 10     | Unlisted                          | 0     | 0    | 100 times a day                            | 2     | 20   | 500 times, 20 min limit                                      | 1     | 10   | 300 min        | 1     | 10   | 2000 min, free for public repos                  | 2     | 20   | 400 min on SaaS + selfhosted                                   | 3     | 30   | Unlisted                                      | 0     | 0    | GitHub Actions                                                                   | 1     | 10   |
| Bandwith limits       | Limit set on bandwith / users visiting the site     | 2,5    | 100 GB                            | 1     | 2,5  | 100 GB                                     | 1     | 2,5  | Unlimited                                                    | 0     | 0    | 100 GB         | 1     | 2,5  | 100 GB                                           | 1     | 2,5  | Unlimited                                                      | 3     | 7,5  | Unlimited                                     | 0     | 0    | 100 GB                                                                           | 1     | 2,5  |
| Storage limits        | Limit set on total storage and individual file size | 2,5    | Unlisted                          | 0     | 0    | Unlisted                                   | 0     | 0    | 20,000 total files, 25MB asset limit                         | 1     | 2,5  | 100 GB         | 4     | 10   | 1 GB                                             | 1     | 2,5  | 10 GB                                                          | 3     | 7,5  | 10 GB                                         | 3     | 7,5  | 250 MB                                                                           | 1     | 2,5  |
| Docs                  | Documentation site of the project                   |        | [Render](https://render.com/docs) |       |      | [Vercel](https://vercel.com/docs/concepts) |       |      | [Cloudflare Pages](https://developers.cloudflare.com/pages/) |       |      | Netlify        |       |      | [GitHub Pages](https://docs.github.com/en/pages) |       |      | [GitLab Pages](https://docs.gitlab.com/ee/user/project/pages/) |       |      | [Hostman](https://hostman.com/docs/overview/) |       |      | [Azure Static Web Apps](https://docs.microsoft.com/en-us/azure/static-web-apps/) |       |      |
|                       |                                                     |        | Total                             | 3     | 22,5 | Total                                      | 4     | 32,5 | Total                                                        | 4     | 32,5 | Total          | 7     | 32,5 | Total                                            | 5     | 35   | Total                                                          | 13    | 95   | Total                                         | 6     | 37,5 | Total                                                                            | 8     | 75   |
|                       |                                                     |        |                                   |       |      |                                            |       |      |                                                              |       |      |                |       |      |                                                  |       |      |                                                                |       |      |                                               |       |      |                                                                                  |       |      |

## Test tooling

Test tooling, either for security or other purposes would preferably be consolidated or bundled in one tool. These consilidated tools or bundles should accept custom tools not natively supported by them for extendability purposes.

**Examples:**
SuperLinter
MegaLinter
ShiftLeftSecurity sast scan
SecureCodeBox
HuskyCI
kubernetes-validation-tools
Gauntlt

Testing frameworks
Pentest frameworks

All results should be sent to a centralized location for storage, visualization, ad-hoc analysis and remediation steps.

**Examples:**

DefectDojo
Elasticsearch + Kibana
ArcherySec
Faraday